var visibleTabs = new Array();

function showStickyNote(tabId, hostname) {
    visibleTabs.push(tabId + "_" + hostname);
    addHtml(hostname);
}

function hideStickyNote(tabId, hostname) {
    visibleTabs = remove(visibleTabs, tabId + "_" + hostname);
    removeHtml();
}

function addHtml(hostname) {
    chrome.tabs.executeScript(null, {
        code: "var hostname = '" + hostname + "';"
    }, function() {
        chrome.tabs.executeScript(null, {file: '/prepareHtmlStickyNote.js'});
    });

}

function removeHtml() {
    chrome.tabs.executeScript(null, { file: "/removeHtmlStickyNote.js" });
}

function onClickHandler(info, tab) {

    let hostname = new URL(tab.url).hostname;

    if (visibleTabs.includes(tab.id + "_" + hostname) === false) {
        console.debug("Show stickyNote for " + hostname);
        showStickyNote(tab.id, hostname);
    } else {
        console.debug("Hide stickyNote for " + hostname);
        hideStickyNote(tab.id, hostname);
    }
};

chrome.contextMenus.onClicked.addListener(onClickHandler);

// Set up context menu tree at install time.
chrome.runtime.onInstalled.addListener(function() {

    let item = {
        "title": "WuBrowser: StickyNotes",
        "contexts": ["page"],
        "id": "context-page"

    };

    chrome.contextMenus.create(item);

});

// helpers
function remove(array, element) {
    return array.filter(e => e !== element);
}