var css = document.createElement("style");
css.type = "text/css";
css.innerHTML = "[WuBrowser-StickyNote-Contenteditable=true]:empty:before{ content: attr(placeholder); display: block; };";
document.body.appendChild(css);

var wuBrowserStickyNote = document.createElement('div');

//set attributes for div
wuBrowserStickyNote.id = 'WuBrowser-StickyNote';
wuBrowserStickyNote.style.position = 'fixed';
wuBrowserStickyNote.style.zIndex = '9999';
wuBrowserStickyNote.style.backgroundColor = '#FFFAF0';
wuBrowserStickyNote.style.border = '1px solid #000';
wuBrowserStickyNote.style.textAlign = 'left';
wuBrowserStickyNote.style.font = 'normal 12px serif';
wuBrowserStickyNote.style.color = '#000';
wuBrowserStickyNote.style.minWidth = '100px';
wuBrowserStickyNote.style.minHeight = '40px';
wuBrowserStickyNote.style.cursor = 'move';
wuBrowserStickyNote.style.padding = '2px';
wuBrowserStickyNote.style.top = "60px";
wuBrowserStickyNote.style.left = "calc(100% - 120px)"; // 100px min width + 20 with margin

wuBrowserStickyNote.setAttribute('contenteditable', "true");
wuBrowserStickyNote.setAttribute('placeholder', "Enter text here...");
wuBrowserStickyNote.setAttribute('WuBrowser-StickyNote-Contenteditable', "true");


document.body.appendChild(wuBrowserStickyNote);


// Read value from local storage
var storage = chrome.storage.local;

storage.get(hostname, function(items) {
    if (items && items.hasOwnProperty([hostname])) {
        wuBrowserStickyNote.innerText = items[hostname][0];
    } else {
        console.debug("cannot get items for " + hostname);
    }
});

// append listener
wuBrowserStickyNote.addEventListener("input", function() {

    let value = wuBrowserStickyNote.innerText;

    if (value.length === 0) {
        storage.remove(hostname, function() {
            console.debug("remove for " + hostname);
        });
    } else {
        storage.set({
            [hostname]: [value]
        }, function() {
            console.debug("save new value " + value + " for key " + hostname);
        });
    }

}, false);


//Make the DIV element draggagle:
dragElement(document.getElementById(("WuBrowser-StickyNote")));

function dragElement(elmnt) {
    var pos1 = 0,
        pos2 = 0,
        pos3 = 0,
        pos4 = 0;
    if (document.getElementById(elmnt.id)) {
        /* if present, the header is where you move the DIV from:*/
        document.getElementById(elmnt.id).onmousedown = dragMouseDown;
    } else {
        /* otherwise, move the DIV from anywhere inside the DIV:*/
        elmnt.onmousedown = dragMouseDown;
    }

    function dragMouseDown(e) {
        e = e || window.event;
        // get the mouse cursor position at startup:
        pos3 = e.clientX;
        pos4 = e.clientY;

        document.onmouseup = closeDragElement;
        // call a function whenever the cursor moves:
        document.onmousemove = elementDrag;
    }

    function elementDrag(e) {
        e = e || window.event;
        // calculate the new cursor position:
        pos1 = pos3 - e.clientX;
        pos2 = pos4 - e.clientY;
        pos3 = e.clientX;
        pos4 = e.clientY;
        // set the element's new position:
        elmnt.style.top = (elmnt.offsetTop - pos2) + "px";
        elmnt.style.left = (elmnt.offsetLeft - pos1) + "px";
    }

    function closeDragElement() {
        /* stop moving when mouse button is released:*/
        document.onmouseup = null;
        document.onmousemove = null;
    }
}